Object.equals = function (x, y) {
  if (x === y) return true;
  if (!(x instanceof Object) || !(y instanceof Object)) return false;
  if (x.constructor !== y.constructor) return false;

  for (var p in x) {
    if (!x.hasOwnProperty(p)) continue;
    if (!y.hasOwnProperty(p)) return false;
    if (x[p] === y[p]) continue;
    if (typeof x[p] !== "object") return false;
    if (!Object.equals(x[p], y[p])) return false;
  }

  for (p in y) {
    if (y.hasOwnProperty(p) && !x.hasOwnProperty(p)) return false;
  }
  return true;
};

let AutoTuner = function () { };

AutoTuner.prototype.run = function () {
  try {
    let extenders = false;
    for (i in virtualZone) {
      if (virtualZone[i].typeDev === "ext") {
        extenders = !extenders ? !extenders : extenders;
      }
    }
    if (extenders) {
      alert("Не удалось выполнить автонастройку. Удалите расширители из конфигурации прибора.");
    } else {
      //return this.allDevice();
      this.deviceNeedTune();
      this.fixDevice();
    }
  } catch (error) {
    console.log(error);
  }
};

AutoTuner.prototype.btnDisplay = function () {
  try {
    if (DEVICEMODEL.indexOf("208") != -1) {
      let extenders = false;
      for (i in virtualZone) {
        if (virtualZone[i].typeDev === "ext") {
          extenders = !extenders ? !extenders : extenders;
        }
      }
      if (extenders) {
        return false;
      } else {
        return true;
      }
    } else {
      return false;
    }
  } catch (error) {
    console.log(error);
  }
};

AutoTuner.prototype.allDevice = function () {
  this.DeviceAll = [];
  try {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key.indexOf("xxad") != -1 && deviceJSON.config[i].key !== "xxad0") {
        if (deviceJSON.config[i].subvalues[1].value !== "0") {
          let device = {};
          device.adress = deviceJSON.config[i].key.slice(4);
          let XXDR = "xxdr" + device.adress;
          device.sensor1 = this.parseKey()[XXDR][0].value;
          device.sensor2 = this.parseKey()[XXDR][1].value;
          this.DeviceAll.push(device);
        }
      }
    }
    return this.DeviceAll;
  } catch (error) {
    spiner_stop();
    console.log(error);
    alert("Не удалось выполнить автонастройку");
    return "error";
  }
};

AutoTuner.prototype.deviceNeedTune = function () {
  this.device = [];
  try {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key.indexOf("xxad") != -1 && deviceJSON.config[i].key !== "xxad0") {
        if (deviceJSON.config[i].subvalues[1].value !== "0") {
          let device = {};
          device.adress = deviceJSON.config[i].key.slice(4);
          let XXDR = "xxdr" + device.adress;
          let XXAD = "xxad" + device.adress;
          device.sensor1 = this.parseKey()[XXDR][0].value;
          device.sensor2 = this.parseKey()[XXDR][1].value;

          if (
            (device.adress !== device.sensor1 && device.sensor1 !== "0") ||
            (100 + parseInt(device.adress) !== parseInt(device.sensor2) && device.sensor2 !== "0")
          ) {
            let LW1 = "lw" + this.parseKey()[XXDR][0].value;
            let LW2 = "lw" + this.parseKey()[XXDR][1].value;
            let YZ1 = "yz" + this.parseKey()[XXDR][0].value;
            let YZ2 = "yz" + this.parseKey()[XXDR][1].value;
            device.config = (function () {
              let res = {};
              for (k in deviceJSON.config) {
                if (
                  deviceJSON.config[k].key === LW1 ||
                  deviceJSON.config[k].key === LW2 ||
                  deviceJSON.config[k].key === YZ1 ||
                  deviceJSON.config[k].key === YZ2 ||
                  deviceJSON.config[k].key === XXDR ||
                  deviceJSON.config[k].key === XXAD
                ) {
                  res[deviceJSON.config[k].key] = deviceJSON.config[k];
                }
              }
              return res;
            })();
            this.device.push(device);
          }
        }
      }
    }
    return this.device;
  } catch (error) {
    spiner_stop();
    console.log(error);
    alert("Не удалось выполнить автонастройку");
    return "error";
  }
};

AutoTuner.prototype.parseKey = function () {
  try {
    this.Key = {};
    for (i in deviceJSON.config) {
      this.Key[deviceJSON.config[i].key] = deviceJSON.config[i].subvalues;
    }
    return this.Key;
  } catch (error) {
    spiner_stop();
    console.log(error);
    alert("Не удалось выполнить автонастройку");
    return "error";
  }
};

AutoTuner.prototype.createDevice = function (deviceList) {
  this.Device = {};
  try {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key.indexOf("xxad") != -1 && deviceJSON.config[i].key !== "xxad0") {
        if (deviceJSON.config[i].subvalues[1].value === "0") {
          let device = {};
          device.adress = deviceJSON.config[i].key.slice(4);
          let XXDR = "xxdr" + device.adress;
          let LW1 = "lw" + this.parseKey()[XXDR][0].value;
          let LW2 = "lw" + this.parseKey()[XXDR][1].value;
          let YZ1 = "yz" + this.parseKey()[XXDR][0].value;
          let YZ2 = "yz" + this.parseKey()[XXDR][1].value;
          device.sensor1 = device.adress;
          device.sensor2 = 100 + parseInt(device.adress) + "";
          device.options = (function () {
            let res = [];
            for (k in deviceJSON.config) {
              if (
                deviceJSON.config[k].key === LW1 ||
                deviceJSON.config[k].key === LW2 ||
                deviceJSON.config[k].key === YZ1 ||
                deviceJSON.config[k].key === YZ2
              ) {
                res.push(deviceJSON.config[k]);
              }
            }
            return res;
          })();
          return (this.Device = device);
        }
      }
    }
    return this.Device;
  } catch (error) {
    spiner_stop();
    console.log(error);
    alert("Не удалось выполнить автонастройку");
    return "error";
  }
};

AutoTuner.prototype.fixDevice = function (deviceList) {
  try {
    let error = false;
    if (this.parseKey()["zs"]) {
      let integralZoneArr = this.parseKey()["zs"][0].value ? this.parseKey()["zs"][0].value.split(",") : [];
      if (integralZoneArr.length == 1) {
        if (integralZoneArr[0] == "1") {
          if (
            (this.parseKey()["lw193"][0].value === "0" &&
              this.parseKey()["lw193"][1].value === "0" &&
              this.parseKey()["lw193"][2].value === "0") ||
            this.parseKey()["zs"][1].value == "193"
          ) {
            if (this.parseKey()["zs"][1].value !== "193") {
              for (k in deviceJSON.config) {
                if (deviceJSON.config[k].key == "lw193") {
                  deviceJSON.config[k].subvalues[0].value = this.parseKey()["lw1"][0].value;
                  deviceJSON.config[k].subvalues[1].value = this.parseKey()["lw1"][1].value;
                  deviceJSON.config[k].subvalues[2].value = this.parseKey()["lw1"][2].value;
                  saveConfig(deviceJSON.config[k]);
                } else if (deviceJSON.config[k].key == "zs") {
                  deviceJSON.config[k].subvalues[0].value = "1";
                  deviceJSON.config[k].subvalues[1].value = "193";
                  saveConfig(deviceJSON.config[k]);
                } else if (deviceJSON.config[k].key == "yz193") {
                  deviceJSON.config[k].subvalues[0].value = this.parseKey()["yz1"][0].value;
                  saveConfig(deviceJSON.config[k]);
                }
              }
            }
          } else {
            error = !error;
            console.log("Не удалось выполнить автонастройку, измените номер зоны 1 либо освободите 193 зону");
          }
        }
      }
    }
    if (!error) {
      for (i in this.device) {
        let xxdrKey = "xxdr" + this.device[i].adress;
        let lwKey1 = "lw" + this.device[i].adress;
        let lwKey2 = "lw" + (100 + parseInt(this.device[i].adress));
        let yz1 = "yz" + this.device[i].adress;
        let yz2 = "yz" + (100 + parseInt(this.device[i].adress));

        let olddSensor1 = this.device[i].config["xxdr" + this.device[i].adress].subvalues[0].value;
        let olddSensor2 = this.device[i].config["xxdr" + this.device[i].adress].subvalues[1].value;

        let oldLwKey1 = "lw" + olddSensor1;
        let oldLwKey2 = "lw" + olddSensor2;
        let oldYz1 = "yz" + olddSensor1;
        let oldYz2 = "yz" + olddSensor2;

        for (k in deviceJSON.config) {
          if (deviceJSON.config[k].key == xxdrKey) {
            deviceJSON.config[k].subvalues[0].value = this.device[i].adress;
            deviceJSON.config[k].subvalues[1].value = 100 + parseInt(this.device[i].adress) + "";
            saveConfig(deviceJSON.config[k]);
          } else if (deviceJSON.config[k].key == lwKey1) {
            deviceJSON.config[k].subvalues[0].value = this.device[i].config[oldLwKey1].subvalues[0].value;
            deviceJSON.config[k].subvalues[1].value = this.device[i].config[oldLwKey1].subvalues[1].value;
            deviceJSON.config[k].subvalues[2].value = this.device[i].config[oldLwKey1].subvalues[2].value;
            saveConfig(deviceJSON.config[k]);
          } else if (deviceJSON.config[k].key == lwKey2) {
            deviceJSON.config[k].subvalues[0].value = this.device[i].config[oldLwKey2].subvalues[0].value;
            deviceJSON.config[k].subvalues[1].value = this.device[i].config[oldLwKey2].subvalues[1].value;
            deviceJSON.config[k].subvalues[2].value = this.device[i].config[oldLwKey2].subvalues[2].value;
            saveConfig(deviceJSON.config[k]);
          } else if (deviceJSON.config[k].key == yz1) {
            deviceJSON.config[k].subvalues[0].value = this.device[i].config[oldYz1].subvalues[0].value;
            saveConfig(deviceJSON.config[k]);
          } else if (deviceJSON.config[k].key == yz2) {
            deviceJSON.config[k].subvalues[0].value = this.device[i].config[oldYz2].subvalues[0].value;
            saveConfig(deviceJSON.config[k]);
          }
        }
      }

      return parseAppKey("update_notabs");
    } else {
      return alert("Не удалось выполнить автонастройку");
    }
    //return deviceList;
  } catch (error) {
    spiner_stop();
    console.log(error);
    alert("Не удалось выполнить автонастройку");
    return "error";
  }
};

AutoTuner.prototype.saveDevice = function (device) {
  try {
    for (i in device) {
      console.log(device[i]);
    }
  } catch (error) {
    spiner_stop();
    console.log(error);
    alert("Не удалось выполнить автонастройку");
    return "error";
  }
};

AutoTuner.prototype.removeDevice = function (device) {
  try {
    for (d in device) {
      let XXAD = "xxad" + device[d].adress;
      let XXDR = "xxdr" + device[d].adress;
      let LW1 = "lw" + device[d].sensor1;
      let LW2 = "lw" + device[d].sensor2;

      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == XXAD) {
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          deviceJSON.config[i].subvalues[2].value = "0";
          deviceJSON.config[i].subvalues[3].value = "0";
          saveConfig(deviceJSON.config[i]);
        } else if (
          deviceJSON.config[i].key == XXDR ||
          deviceJSON.config[i].key == LW1 ||
          deviceJSON.config[i].key == LW2
        ) {
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          saveConfig(deviceJSON.config[i]);
        }
      }
    }
  } catch (error) {
    spiner_stop();
    console.log(error);
    alert("Не удалось выполнить автонастройку");
    return "error";
  }
};


function update_rkps_OLD1() {
  //alertbox.show('Обновлены данные через радиоканал');

  var xhr = new XMLHttpRequest();
  xhr.open("GET", vhost + "/device?id=" + TUNER_DEVICE_ID + "&configstate=xxds", true);

  xhr.onreadystatechange = function (oEvent) {
    if (xhr.readyState === 4) {
      if (xhr.status === 200) {
        data = JSON.parse(xhr.responseText); // ответ
        for (i in data.result.config) {
          if (data.result.config[i].key.indexOf("xxds") != -1) {
            if (data.result.config[i].subvalues[5].value & 0x10) {
              let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
              let rkps_dom, value;
              // НАПРЯЖЕНИЕ ...
              rkps_dom = document.getElementById("rkps_napr_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[0].value + " мВ";
                document.getElementById("rkps_napr_" + rkps_number)
                  ? (document.getElementById("rkps_napr_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ...

              // ТЕМПЕРАТУРА ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value =
                  data.result.config[i].subvalues[1].value.replace("!", "").replace("*", "-").replace("-0", "0") +
                  " &#8451;";
                document.getElementById("rkps_t_" + rkps_number)
                  ? (document.getElementById("rkps_t_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... ТЕМПЕРАТУРА

              // СИГНАЛ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[2].value;
                if (value < 140) {
                  value = 0;
                } else {
                  value = value - 140;
                }
                document.getElementById("rkps_signal_" + rkps_number)
                  ? (document.getElementById("rkps_signal_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... СИГНАЛ

              // ПО ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[3].value;
                document.getElementById("rkps_soft_" + rkps_number)
                  ? (document.getElementById("rkps_soft_" + rkps_number).innerHTML =
                    value.charAt(0) + "." + value.charAt(2) + value.charAt(1))
                  : "";
              }
              // ... ПО

              // ЖЕЛЕЗО ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[4].value;
                document.getElementById("rkps_hard_" + rkps_number)
                  ? (document.getElementById("rkps_hard_" + rkps_number).innerHTML =
                    value.charAt(0) + "." + value.charAt(1))
                  : "";
              }
              // ... ЖЕЛЕЗО

              // КОРПУС ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x1) {
                  value = '<span style="color:red">Открыт</span>';
                } else {
                  value = '<span style="color:green">Закрыт</span>';
                }
                document.getElementById("rkps_corpus_" + rkps_number)
                  ? (document.getElementById("rkps_corpus_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... КОРПУС

              // ИНДИКАЦИЯ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x2) {
                  value = '<span style="color:green">вкл</span>';
                } else {
                  value = "выкл";
                }
                document.getElementById("rkps_indika_" + rkps_number)
                  //  ? (document.getElementById("rkps_indika_" + rkps_number).innerHTML = value)
                  ? (document.getElementById("rkps_indika_" + rkps_number).innerHTML = "0-25-22-65")
                  : "";
              }
              // ... ИНДИКАЦИЯ

              // ПИТАНИЕ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                //if (value & 0x4) {
                if (value & 0x8) {
                  value = '<span style="color:red">Снижено</span>';
                } else {
                  value = '<span style="color:green">Норма</span>';
                }
                document.getElementById("rkps_power_" + rkps_number)
                  ? (document.getElementById("rkps_power_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... ПИТАНИЕ

              // БАТАРЕЯ 2...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x8) {
              //         value = '<span style="color:red">Разряжена</span>';
              //     } else {
              //         value = '<span style="color:green">Норма</span>';
              //     }
              //     document.getElementById('rkps_powerBank_' + rkps_number) ? document.getElementById('rkps_powerBank_' + rkps_number).innerHTML = value : "";
              // }
              // ... БАТАРЕЯ 2

              // ПР запрограммировано ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x10) {
              //         value = 'Запрог.';
              //     } else {
              //         value = 'Нет';
              //     }
              //     document.getElementById('rkps_program_' + rkps_number) ? document.getElementById('rkps_program_' + rkps_number).innerHTML = value : "";
              // }
              // ... ПР запрограммировано

              // ИН инициализировано ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x40) {
              //         value = 'Иниц.';
              //     } else {
              //         value = 'Не иниц.';
              //     }
              //     document.getElementById('rkps_init_' + rkps_number) ? document.getElementById('rkps_init_' + rkps_number).innerHTML = value : "";
              // }
              // ... ИН инициализировано

              // Состояние РУ
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x40) {
                  //Инициализирован
                  value = "Иниц.";
                } else if (value & 0x10) {
                  // Запрограммирован
                  value = "Запрог.";
                } else {
                  // Нет
                  value = "Нет";
                }
                document.getElementById("rkps_program_" + rkps_number)
                  ? (document.getElementById("rkps_program_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ...Состояние РУ

              // ПР запрограммировано ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x20) {
              //         value = 'Зарег.';
              //     } else {
              //         value = 'Не зарег.';
              //     }
              //     document.getElementById('rkps_registr_' + rkps_number).innerHTML = value;
              // }
              // ... ПР запрограммировано

              // БЛ заблокировано ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x80) {
              //         value = '<span style="color:red">Заблок.</span>';
              //     } else {
              //         value = 'Штатно.';
              //     }
              //     document.getElementById('rkps_lock_' + rkps_number) ? document.getElementById('rkps_lock_' + rkps_number).innerHTML = value : "";
              // }
              // ... БЛ заблокировано

              // СВЯЗЬ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                //ДОКИНУЛ СЮДА ОТ ГРЕХА ПОДАЛЬШЕ
                if (rkps_device[rkps_number].name != "16370") {
                  value = data.result.config[i].subvalues[5].value;
                  if (value & 0x100) {
                    value = '<span style="color:red">Нет</span>';
                  } else {
                    value = '<span style="color:green">Есть</span>';
                  }
                  document.getElementById("rkps_connect_" + rkps_number)
                    ? (document.getElementById("rkps_connect_" + rkps_number).innerHTML = value)
                    : "";
                }
              }
              // ... СВЯЗЬ

              // ОСНОВНАЯ ЗОНА НАРУШЕНА ...
              value = "";
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              let styleZoneRkps = "";
              let textNumberZone = "";
              if (rkps_dom) {
                let valNmbtZone_1 = rkps_device[rkps_number].zone_1;
                for (var k = 0; k < virtualZone.length; k++) {
                  if (
                    data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) &&
                    "1" == virtualZone[k].index
                  ) {
                    if (virtualZone[k].type == "1" && virtualZone[k].param == "0" && virtualZone[k].delay == "0") {
                      value = "Зона №" + valNmbtZone_1 + "</br>";
                      value += "Исключена";
                    }
                  }
                }
                if (value !== "Исключена") {
                  value = data.result.config[i].subvalues[5].value;

                  if (value & 0x200) {
                    //    $.styleRkpsZone(rkps_number, '')
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #f44336; ">' +
                      valNmbtZone_1 +
                      "</div></br>";
                    value += '<div style="float:left"><span style="">Нарушена</span></div>';
                  } else {
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #468966; ">' +
                      valNmbtZone_1 +
                      "</div></br>";
                    value += '<div style="width:80px"><span style="float:left">В норме</span></div>';
                  }

                  document.getElementById("rkps_ozn_" + rkps_number)
                    ? (document.getElementById("rkps_ozn_" + rkps_number).innerHTML = value)
                    : "";
                  document.getElementById("rkps_ozn_" + rkps_number)
                    ? $.removeClass(".rkps_ozn_" + rkps_number, "w3-red")
                    : "";
                } else {
                  document.getElementById("rkps_ozn_" + rkps_number)
                    ? (document.getElementById("rkps_ozn_" + rkps_number).innerHTML = value)
                    : "";
                }
              }
              // ... ОСНОВНАЯ ЗОНА НАРУШЕНА

              // ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА ...
              value = "";
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                let valNmbtZone_2 = rkps_device[rkps_number].zone_2;

                for (var k = 0; k < virtualZone.length; k++) {
                  if (
                    data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) &&
                    "2" == virtualZone[k].index
                  ) {
                    if (virtualZone[k].type == "1" && virtualZone[k].param == "0" && virtualZone[k].delay == "0") {
                      value = "Зона №" + valNmbtZone_2 + "</br>";
                      value += "Исключена";
                    }
                  }
                }

                if (value !== "Исключена") {
                  value = data.result.config[i].subvalues[5].value;
                  textNumberZone = "Зона №" + valNmbtZone_2 + "</br>";
                  if (value & 0x400) {
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #f44336; ">' +
                      valNmbtZone_2 +
                      "</div></br>";
                    value += '<div style="float:left"><span style="">Нарушена</span></div>';
                  } else {
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #468966; ">' +
                      valNmbtZone_2 +
                      "</div></br>";
                    value += '<div style="width:80px"><span style="float:left">В норме</span></div>';
                  }
                  document.getElementById("rkps_dzn_" + rkps_number)
                    ? (document.getElementById("rkps_dzn_" + rkps_number).innerHTML = value)
                    : "";
                } else {
                  document.getElementById("rkps_dzn_" + rkps_number)
                    ? (document.getElementById("rkps_dzn_" + rkps_number).innerHTML = value)
                    : "";
                }
              }
              // ... ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА

              // САБОТАЖ ОСНОВНОЙ ЗОНЫ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x800) {
                  value = '<span style="color:red">Саботаж</span>';
                } else {
                  value = "";
                }
                document.getElementById("rkps_sabotag_" + rkps_number)
                  ? (document.getElementById("rkps_sabotag_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... САБОТАЖ ОСНОВНОЙ ЗОНЫ

              // РП резервное питание ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x1000) {
              //         value = 'Резерв.';
              //     } else {
              //         value = 'Осн.';
              //     }
              //     document.getElementById('rkps_rezervpower_' + rkps_number) ? document.getElementById('rkps_rezervpower_' + rkps_number).innerHTML = value : "";
              // }
              //... РП резервное питание
            } else {
              let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
              document.getElementById("rkps_program_" + rkps_number)
                ? (document.getElementById("rkps_program_" + rkps_number).innerHTML =
                  '<span style="color:red">Нет</span>')
                : "";
            }
          } // До сюда
        }
      }
    }
  };
  xhr.send();
}

function update_rkps_OLD2() {
  //alertbox.show('Обновлены данные через радиоканал');

  var xhr = new XMLHttpRequest();
  xhr.open("GET", vhost + "/device?id=" + TUNER_DEVICE_ID + "&configstate=xxds", true);

  xhr.onreadystatechange = function (oEvent) {
    if (xhr.readyState === 4) {
      if (xhr.status === 200) {
        data = JSON.parse(xhr.responseText); // ответ
        for (i in data.result.config) {
          if (data.result.config[i].key.indexOf("xxds") != -1) {
            if (data.result.config[i].subvalues[5].value & 0x10) {
              let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
              let rkps_dom, value;
              // НАПРЯЖЕНИЕ ...
              rkps_dom = document.getElementById("rkps_napr_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[0].value + " мВ";
                document.getElementById("rkps_napr_" + rkps_number)
                  ? (document.getElementById("rkps_napr_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ...

              // ТЕМПЕРАТУРА ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value =
                  data.result.config[i].subvalues[1].value.replace("!", "").replace("*", "-").replace("-0", "0") +
                  " &#8451;";
                document.getElementById("rkps_t_" + rkps_number)
                  ? (document.getElementById("rkps_t_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... ТЕМПЕРАТУРА

              // СИГНАЛ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[2].value;
                document.getElementById("rkps_signal_" + rkps_number)
                  ? (document.getElementById("rkps_signal_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... СИГНАЛ

              // ПО ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[3].value;
                document.getElementById("rkps_soft_" + rkps_number)
                  ? (document.getElementById("rkps_soft_" + rkps_number).innerHTML =
                    value.charAt(0) + "." + value.charAt(2) + value.charAt(1))
                  : "";
              }
              // ... ПО

              // ЖЕЛЕЗО ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[4].value;
                document.getElementById("rkps_hard_" + rkps_number)
                  ? (document.getElementById("rkps_hard_" + rkps_number).innerHTML =
                    value.charAt(0) + "." + value.charAt(1))
                  : "";
              }
              // ... ЖЕЛЕЗО

              // КОРПУС ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x1) {
                  value = '<span style="color:red">Корпус открыт</span>';
                } else {
                  value = '<span style="color:green">Корпус закрыт</span>';
                }
                document.getElementById("rkps_corpus_" + rkps_number)
                  ? (document.getElementById("rkps_corpus_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... КОРПУС

              // ИНДИКАЦИЯ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));

              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x2) {
                  value = '<span style="color:green">вкл</span>';
                } else {
                  value = "выкл";
                }
                document.getElementById("rkps_indika_" + rkps_number)
                  ? (document.getElementById("rkps_indika_" + rkps_number).innerHTML = "0>5>12>65")
                  //      ? (document.getElementById("rkps_indika_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... ИНДИКАЦИЯ

              // ПИТАНИЕ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x4) {
                  value = "Резерв.";
                } else {
                  value = "Основ.";
                }
                document.getElementById("rkps_power_" + rkps_number)
                  ? (document.getElementById("rkps_power_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... ПИТАНИЕ

              // БАТАРЕЯ 2...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x8) {
              //         value = '<span style="color:red">Разряжена</span>';
              //     } else {
              //         value = '<span style="color:green">Норма.</span>';
              //     }
              //     document.getElementById('rkps_powerBank_' + rkps_number) ? document.getElementById('rkps_powerBank_' + rkps_number).innerHTML = value : "";
              // }
              // ... БАТАРЕЯ 2

              // ПР запрограммировано ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x10) {
                  value = "Запрог.";
                } else {
                  value = "Нет";
                }
                document.getElementById("rkps_program_" + rkps_number)
                  ? (document.getElementById("rkps_program_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... ПР запрограммировано

              // ПР запрограммировано ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x20) {
              //         value = 'Зарег.';
              //     } else {
              //         value = 'Не зарег.';
              //     }
              //     document.getElementById('rkps_registr_' + rkps_number).innerHTML = value;
              // }
              // ... ПР запрограммировано

              // ИН инициализировано ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x40) {
              //         value = 'Иниц.';
              //     } else {
              //         value = 'Не иниц.';
              //     }
              //     document.getElementById('rkps_init_' + rkps_number) ? document.getElementById('rkps_init_' + rkps_number).innerHTML = value : "";
              // }
              // ... ИН инициализировано

              // БЛ заблокировано ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x80) {
              //         value = '<span style="color:red">Заблок.</span>';
              //     } else {
              //         value = 'Штатно.';
              //     }
              //     document.getElementById('rkps_lock_' + rkps_number) ? document.getElementById('rkps_lock_' + rkps_number).innerHTML = value : "";
              // }
              // // ... БЛ заблокировано

              // СВЯЗЬ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                //ДОКИНУЛ СЮДА ОТ ГРЕХА ПОДАЛЬШЕ
                if (rkps_device[rkps_number].name != "16370") {
                  value = data.result.config[i].subvalues[5].value;
                  if (value & 0x100) {
                    value = '<span style="color:red">Нет</span>';
                  } else {
                    value = '<span style="color:green">Есть</span>';
                  }
                  document.getElementById("rkps_connect_" + rkps_number)
                    ? (document.getElementById("rkps_connect_" + rkps_number).innerHTML = value)
                    : "";
                }
              }
              // ... СВЯЗЬ

              // ОСНОВНАЯ ЗОНА НАРУШЕНА ...
              value = "";
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                for (var k = 0; k < virtualZone.length; k++) {
                  if (
                    data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) &&
                    "1" == virtualZone[k].index
                  ) {
                    if (virtualZone[k].type == "1" && virtualZone[k].param == "0" && virtualZone[k].delay == "0") {
                      value = "Исключена";
                    }
                  }
                }
                if (value !== "Исключена") {
                  value = data.result.config[i].subvalues[5].value;
                  if (value & 0x200) {
                    value = '<span style="color:red">Нарушена</span>';
                  } else {
                    value = '<span style="color:green">В норме</span>';
                  }

                  document.getElementById("rkps_ozn_" + rkps_number)
                    ? (document.getElementById("rkps_ozn_" + rkps_number).innerHTML = value)
                    : "";
                } else {
                  document.getElementById("rkps_ozn_" + rkps_number)
                    ? (document.getElementById("rkps_ozn_" + rkps_number).innerHTML = value)
                    : "";
                }
              }
              // ... ОСНОВНАЯ ЗОНА НАРУШЕНА

              // ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА ...
              value = "";
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                for (var k = 0; k < virtualZone.length; k++) {
                  if (
                    data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) &&
                    "2" == virtualZone[k].index
                  ) {
                    if (virtualZone[k].type == "1" && virtualZone[k].param == "0" && virtualZone[k].delay == "0") {
                      value = "Исключена";
                    }
                  }
                }

                if (value !== "Исключена") {
                  value = data.result.config[i].subvalues[5].value;
                  if (value & 0x400) {
                    value = '<span style="color:red">Нарушена<span>';
                  } else {
                    value = '<span style="color:green">В норме</span>';
                  }
                  document.getElementById("rkps_dzn_" + rkps_number)
                    ? (document.getElementById("rkps_dzn_" + rkps_number).innerHTML = value)
                    : "";
                } else {
                  document.getElementById("rkps_dzn_" + rkps_number)
                    ? (document.getElementById("rkps_dzn_" + rkps_number).innerHTML = value)
                    : "";
                }
              }
              // ... ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА

              // САБОТАЖ ОСНОВНОЙ ЗОНЫ ...
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                value = data.result.config[i].subvalues[5].value;
                if (value & 0x800) {
                  value = '<span style="color:red">Саботаж</span>';
                } else {
                  value = "";
                }
                document.getElementById("rkps_sabotag_" + rkps_number)
                  ? (document.getElementById("rkps_sabotag_" + rkps_number).innerHTML = value)
                  : "";
              }
              // ... САБОТАЖ ОСНОВНОЙ ЗОНЫ

              // РП резервное питание ...
              // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              // if (rkps_dom) {
              //     value = data.result.config[i].subvalues[5].value;
              //     if (value & 0x1000) {
              //         value = 'Резерв.';
              //     } else {
              //         value = 'Осн.';
              //     }
              //     document.getElementById('rkps_rezervpower_' + rkps_number) ? document.getElementById('rkps_rezervpower_' + rkps_number).innerHTML = value : "";
              // }
              //... РП резервное питание
            } else {
              let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
              document.getElementById("rkps_program_" + rkps_number)
                ? (document.getElementById("rkps_program_" + rkps_number).innerHTML =
                  '<span style="color:red">Нет</span>')
                : "";
            }
          } // До сюда
        }
      }
    }
  };
  xhr.send();
}
