let RKPS_XXDS = [];
function isNumberGreaterThanZero(value) {
  const numberValue = parseFloat(value);
  return !isNaN(numberValue) && numberValue > 0       
}
function find_xxss(index) {
  let xxss = ''
  for (j in deviceJSON.config) {
    if (deviceJSON.config[j].key.indexOf("xxss") != -1) {
      if (deviceJSON.config[j].key.slice(4) === index) {
        xxss = Number(deviceJSON.config[j].subvalues[0].value) & 3

      }
    }
  }
  return xxss
}
function disDevice(rkps_number) {
 for (let i = 0; i < virtualRadio.length; i++) {
  const element = virtualRadio[i] 
   if(element.numberRadio === rkps_number && isNumberGreaterThanZero(element.address) && isNumberGreaterThanZero(element.serial)){
    return true
   }
 }
 return false
}
async function update_rkps() {
  //alertbox.show('Обновлены данные через радиоканал');
  try {
    const response = await fetch(vhost + "/device?id=" + TUNER_DEVICE_ID + "&configstate=xxds")
    let data
    if (response.ok) {
      data = await response.json()
    }
    else {
      alert("Ошибка HTTP: " + response.status);
    }
    //data = JSON.parse(xhr.responseText); // ответ
    for (i in data.result.config) {
      if (data.result.config[i].key.indexOf("xxds") != -1) {
        let f6_bit = "";
        let battary_two = "";
        let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
        let devModel = rkps_device[rkps_number] ? rkps_device[rkps_number].name : "";
        if (rkps_device[rkps_number]) {
          if (rkps_device[rkps_number].name == "17620" || rkps_device[rkps_number].name == "16270" || rkps_device[rkps_number].name == "13431" || rkps_device[rkps_number].name == "13438" || rkps_device[rkps_number].name == "13439") {
            f6_bit = data.result.config[i].subvalues[5].value.split(",")[0];
            if (data.result.config[i].subvalues[5].value.split(",")[1]) {
              if (data.result.config[i].subvalues[5].value.split(",")[1].indexOf("%") != -1) {
                battary_two = data.result.config[i].subvalues[5].value.split(",")[1];
              } else {
                battary_two = data.result.config[i].subvalues[5].value.split(",")[1] + " мВ ";
              }
            } else {
            }
          } else {
            f6_bit = data.result.config[i].subvalues[5].value;
          }
 
          const isDevice = disDevice(rkps_number)
          if ((f6_bit & 0x10) && isDevice) {
            // 4 Бит
            let rkps_dom, value;
            // БАТАРЕЯ 1 ...
            rkps_dom = document.getElementById("rkps_napr_" + data.result.config[i].key.slice(4));
            if (rkps_dom) {
              let valuePower;
              if (data.result.config[i].subvalues[0].value.indexOf("%") != -1) {
                valuePower = data.result.config[i].subvalues[0].value;
              } else {
                valuePower = data.result.config[i].subvalues[0].value + " мВ ";
              }
              if (f6_bit & 0x8) {
                // 3 бит разряжена батарея
                value = '<span style="color:red">' + valuePower + "</span>";
              } else {
                value = '<span style="color:green">' + valuePower + " </span>";
              }
              if (rkps_device[rkps_number].name == "16270" || rkps_device[rkps_number].name == "13431" || rkps_device[rkps_number].name == "13438" || rkps_device[rkps_number].name == "13439") {

                if (f6_bit & 0x200) {
                  // 9 бит  основная батарея отсутствует
                  value = '<span style="color:red; margin-left:18px;">Нет</span>';
                  console.log('9 бит основной батареи нет');
                }
              }

              if (rkps_device[rkps_number].name == "13431" || rkps_device[rkps_number].name == "13438" || rkps_device[rkps_number].name == "13439") {
                if (f6_bit & 0x4) {
                  // 2 бит резернвный источник
                  if (valuePower[0] === '0') {
                    value = '<span style="color:red;">Нет</span>';
                  } else {
                    value = '<span style="color:red">' + valuePower + " </span>";
                  }

                }

                if (f6_bit & 0x200) {
                  // 9 бит основной батареи нет
                  value = '<span style="color:red;">Нет</span>';
                }
              }

              document.getElementById("rkps_napr_" + rkps_number)
                ? (document.getElementById("rkps_napr_" + rkps_number).innerHTML = value)
                : "";
            }
            // БАТАРЕЯ 1 ...

            // ТЕМПЕРАТУРА ...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            if (rkps_dom) {
              value =
                data.result.config[i].subvalues[1].value.replace("!", "").replace("*", "-").replace("-0", "0") +
                " &#8451;";
              document.getElementById("rkps_t_" + rkps_number)
                ? (document.getElementById("rkps_t_" + rkps_number).innerHTML = value)
                : "";
            }
            // ... ТЕМПЕРАТУРА

            // СИГНАЛ ...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            if (rkps_dom) {
              value = data.result.config[i].subvalues[2].value;
              if (value < 140) {
                value = 0;
              } else {
                value = value - 140;
              }

              if (value > 30) {
                value = '<span style="color:green">' + value + "</span>";
              } else if (18 < value && value <= 30) {
                value = '<span style="color:#ff9800">' + value + "</span>";
              } else {
                value = '<span style="color:red">' + value + "</span>";
              }

              document.getElementById("rkps_signal_" + rkps_number)
                ? (document.getElementById("rkps_signal_" + rkps_number).innerHTML = value)
                : "";
            }
            // ... СИГНАЛ

            // ПО ...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            if (rkps_dom) {
              value = data.result.config[i].subvalues[3].value;
              document.getElementById("rkps_soft_" + rkps_number)
                ? (document.getElementById("rkps_soft_" + rkps_number).innerHTML =
                  value.charAt(0) + "." + value.charAt(2) + value.charAt(1))
                : "";
            }
            // ... ПО

            // ЖЕЛЕЗО ...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            if (rkps_dom) {
              value = data.result.config[i].subvalues[4].value;
              document.getElementById("rkps_hard_" + rkps_number)
                ? (document.getElementById("rkps_hard_" + rkps_number).innerHTML =
                  value.charAt(0) + "." + value.charAt(1))
                : "";
            }
            // ... ЖЕЛЕЗО

            // КОРПУС ...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            if (rkps_dom) {
              value = f6_bit;
              if (value & 0x1) {
                // 0 Бит
                value = '<span style="color:red">Открыт</span>';
              } else {
                value = '<span style="color:green">Закрыт</span>';
              }
              document.getElementById("rkps_corpus_" + rkps_number)
                ? (document.getElementById("rkps_corpus_" + rkps_number).innerHTML = value)
                : "";
            }
            // ... КОРПУС

            // ИНДИКАЦИЯ ...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            let xxrtKey = "xxrt" + data.result.config[i].key.slice(4);
            let value0 = ''
            let value1 = ''
            let value2 = ''
            let value3 = ''
            for (n in deviceJSON.config) {
              if (deviceJSON.config[n].key === xxrtKey) {
                value0 = deviceJSON.config[n].subvalues[0].value
                value1 = deviceJSON.config[n].subvalues[1].value
                value2 = deviceJSON.config[n].subvalues[2].value
                //value3 = deviceJSON.config[n].subvalues[3].value
              }
            }
            if (rkps_dom) {
              // value = f6_bit;
              // if (value & 0x2) {
              //   // 1 Бит
              //   value = '<span style="color:green">вкл</span>';
              // } else {
              //   value = `0-${value0}-${value1}-${value2}`
              // }

              if (value0 == '0') {
                value = '0'
              }
              else if (value0 > '0' && value1 == '0') {
                value = `0-${value0}`
              }
              else if (value0 > '0' && value1 > '0' && value2 == '0') {
                value = `0-${value0}-${value1}`
              }
              else {
                value = `0-${value0}-${value1}-${value2}`
              }


              document.getElementById("rkps_indika_" + rkps_number)
                ? (document.getElementById("rkps_indika_" + rkps_number).innerHTML = value)
                //     ? (document.getElementById("rkps_indika_" + rkps_number).innerHTML = "0-25-22-65")
                : "";
            }
            // ... ИНДИКАЦИЯ

            // ПИТАНИЕ ...
            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            // if (rkps_dom) {
            //   value = data.result.config[i].subvalues[5].value;
            //   //if (value & 0x4) {
            //   if (value & 0x8) {
            //     value = '<span style="color:red">Снижено</span>';
            //   } else {
            //     value = '<span style="color:green">Норма</span>';
            //   }
            //   document.getElementById("rkps_power_" + rkps_number)
            //     ? (document.getElementById("rkps_power_" + rkps_number).innerHTML = value)
            //     : "";
            // }
            // ... ПИТАНИЕ

            // ПР запрограммировано ...
            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            // if (rkps_dom) {
            //     value = data.result.config[i].subvalues[5].value;
            //     if (value & 0x10) {
            //         value = 'Запрог.';
            //     } else {
            //         value = 'Нет';
            //     }
            //     document.getElementById('rkps_program_' + rkps_number) ? document.getElementById('rkps_program_' + rkps_number).innerHTML = value : "";
            // }
            // ... ПР запрограммировано

            // ИН инициализировано ...
            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            // if (rkps_dom) {
            //     value = data.result.config[i].subvalues[5].value;
            //     if (value & 0x40) {
            //         value = 'Иниц.';
            //     } else {
            //         value = 'Не иниц.';
            //     }
            //     document.getElementById('rkps_init_' + rkps_number) ? document.getElementById('rkps_init_' + rkps_number).innerHTML = value : "";
            // }
            // ... ИН инициализировано

            // Состояние РУ
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            if (rkps_dom) {
              value = f6_bit;
              // value = data.result.config[i].subvalues[5].value;
              if (value & 0x40) {
                // 6 Бит
                //Инициализирован
                value = "Иниц.";
              } else if (value & 0x10) {
                // 4 Бит
                // Запрограммирован
                value = "Запрог.";
              } else {
                // Нет
                value = "Нет";
              }
              document.getElementById("rkps_program_" + rkps_number)
                ? (document.getElementById("rkps_program_" + rkps_number).innerHTML = value)
                : "";
            }
            // ...Состояние РУ

            // ПР запрограммировано ...
            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            // if (rkps_dom) {
            //     value = data.result.config[i].subvalues[5].value;
            //     if (value & 0x20) {
            //         value = 'Зарег.';
            //     } else {
            //         value = 'Не зарег.';
            //     }
            //     document.getElementById('rkps_registr_' + rkps_number).innerHTML = value;
            // }
            // ... ПР запрограммировано

            // БЛ заблокировано ...
            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            // if (rkps_dom) {
            //     value = data.result.config[i].subvalues[5].value;
            //     if (value & 0x80) {
            //         value = '<span style="color:red">Заблок.</span>';
            //     } else {
            //         value = 'Штатно.';
            //     }
            //     document.getElementById('rkps_lock_' + rkps_number) ? document.getElementById('rkps_lock_' + rkps_number).innerHTML = value : "";
            // }
            // ... БЛ заблокировано

            // СВЯЗЬ ...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            if (rkps_dom) {
              //Брелок Ю-6370 не контролирует состояние связи так что Д.Б. пустая ячейка
              if (rkps_device[rkps_number].name != "16370") {
                value = f6_bit;
                if (value & 0x100) {
                  // 8 Бит
                  value = '<span style="color:red">Нет</span>';
                } else {
                  value = '<span style="color:green">Есть</span>';
                }
                document.getElementById("rkps_connect_" + rkps_number)
                  ? (document.getElementById("rkps_connect_" + rkps_number).innerHTML = value)
                  : "";
              }
            }
            // ... СВЯЗЬ

            // ОСНОВНАЯ ЗОНА НАРУШЕНА ...
            value = "";
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            let styleZoneRkps = "";
            let textNumberZone = "";
            if (rkps_dom) {
              let valNmbtZone_1 = rkps_device[rkps_number].zone_1;
              for (var k = 0; k < virtualZone.length; k++) {
                if (
                  data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) &&
                  "1" == virtualZone[k].index
                ) {
                  if (virtualZone[k].type == "1" && virtualZone[k].param == "0" && virtualZone[k].delay == "0") {
                    value = "Зона №" + valNmbtZone_1 + "</br>";
                    value += "Исключена";
                    break;
                  }
                }
              }
              if (rkps_device[rkps_number].name != "17620") {

                if (valNmbtZone_1 != "0") {
                  // Если зона используется
                  if (f6_bit & 0x200) {
                    // 9 Бит
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #f44336; ">' +
                      valNmbtZone_1 +
                      "</div></br>";
                    value += '<div style="float:left"><span style="">Нарушена</span></div>';
                  } else {
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #468966; ">' +
                      valNmbtZone_1 +
                      "</div></br>";
                    value += '<div style="width:80px"><span style="float:left">В норме</span></div>';
                  }
                } else {
                  // Если зона не используется
                  if (
                    rkps_device[rkps_number].name != "16370" &&
                    rkps_device[rkps_number].name != "16270" &&
                    rkps_device[rkps_number].name != "13431" &&
                    rkps_device[rkps_number].name != "13438" &&
                    rkps_device[rkps_number].name != "13439"
                  ) {
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:gray ">' +
                      "</div></br>";
                    value += '<div style="width:80px"><span style="float:left;">Не исп.</span></div>';

                  } else if (rkps_device[rkps_number].name === "13431" ||
                    rkps_device[rkps_number].name === "13438" ||
                    rkps_device[rkps_number].name === "13439") {
                    value =
                      `<div style=" width: 0;height: 0;border-left: 30px solid transparent;border-right: 30px solid transparent;   border-bottom: 48px solid gray;"> 
                      <div style="color:white;display:flex;             padding-top:20px;padding-left:6px;                  justify-content: flex-end; ">${find_xxss(rkps_number)}</div> 
                       </div></br>`;
                  }
                  else {
                    value = "";
                  }
                }

                document.getElementById("rkps_ozn_" + rkps_number)
                  ? (document.getElementById("rkps_ozn_" + rkps_number).innerHTML = value)
                  : "";
                document.getElementById("rkps_ozn_" + rkps_number)
                  ? $.removeClass(".rkps_ozn_" + rkps_number, "w3-red")
                  : "";
              } else {
                // РЕЛЕ ПВ
                if (!(f6_bit & 0x800)) {
                  // Батареи 2 нет
                  if (f6_bit & 0x1000) {
                    // 12 Бит ПВ ВКЛ
                    //    $.styleRkpsZone(rkps_number, '')
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; width:50px; float: left; margin-left:10px; text-align: center; background:#468966; ">ПВ' +
                      "</div></br>";
                    value += '<div style="float:left;><span style="padding-left:12px"">ВКЛ</span></div>';
                  } else {
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; width:50px; float: left; margin-left:10px; text-align: center; background:gray; ">ПВ' +
                      "</div></br>";
                    value +=
                      '<div style="width:80px"><span style="float:left; padding-left:12px"">ВЫКЛ</span></div>';
                  }

                  if (f6_bit & 0x4000) {
                    // 14 Бит ПВ КЗ
                    //    $.styleRkpsZone(rkps_number, '')
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; width:50px; float: left; margin-left:10px; text-align: center; background:#ff9800; ">ПВ' +
                      "</div></br>";
                    value += '<div style="float:left;><span style="padding-left:12px"">КЗ</span></div>';
                  }

                  if (f6_bit & 0x8000) {
                    // 15 Бит ПВ ОБРЫВ
                    //    $.styleRkpsZone(rkps_number, '')
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; width:50px; float: left; margin-left:10px; text-align: center; background:#FFF0A5; ">ПВ' +
                      "</div></br>";
                    value += '<div style="float:left;><span style="padding-left:12px"">Обрыв</span></div>';
                  }
                } else {
                  value =
                    '<div style="color:#fff; height:50px;line-height: 50px; width:50px; float: left; margin-left:10px; text-align: center; background:#ff9800; ">ПВ' +
                    "</div></br>";
                  value +=
                    '<div style="float:left;><span style="padding-left:12px""><strike>Питание</strike></span></div>';
                }

                document.getElementById("rkps_ozn_" + rkps_number).innerHTML = value;
              }
            }
            // ... ОСНОВНАЯ ЗОНА НАРУШЕНА

            // ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА ...
            value = "";
            if (rkps_device[rkps_number].name != "17620") {
              rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
              if (rkps_dom) {
                let valNmbtZone_2 = rkps_device[rkps_number].zone_2;

                for (var k = 0; k < virtualZone.length; k++) {
                  if (
                    data.result.config[i].key.slice(4) == virtualZone[k].link.slice(4) &&
                    "2" == virtualZone[k].index
                  ) {
                    if (virtualZone[k].type == "1" && virtualZone[k].param == "0" && virtualZone[k].delay == "0") {
                      value = "Зона №" + valNmbtZone_2 + "</br>";
                      value += "Исключена";
                    }
                  }
                }

                textNumberZone = "Зона №" + valNmbtZone_2 + "</br>";
                if (valNmbtZone_2 != "0") {
                  if (f6_bit & 0x400) {
                    // 10 Бит
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #f44336; ">' +
                      valNmbtZone_2 +
                      "</div></br>";
                    value += '<div style="float:left"><span style="">Нарушена</span></div>';
                  } else {
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:  #468966; ">' +
                      valNmbtZone_2 +
                      "</div></br>";
                    value += '<div style="width:80px"><span style="float:left">В норме</span></div>';
                  }
                } else {
                  // ЕСЛИ ДЗ не используется
                  if (
                    rkps_device[rkps_number].name != "15231" &&
                    rkps_device[rkps_number].name != "15230" &&
                    rkps_device[rkps_number].name != "16270" &&
                    rkps_device[rkps_number].name != "16370" &&
                    rkps_device[rkps_number].name != "13431" &&
                    rkps_device[rkps_number].name != "13438" &&
                    rkps_device[rkps_number].name != "13439"
                  ) {
                    value =
                      '<div style="color:#fff; height:50px;line-height: 50px; border-radius: 50%; width:50px; float: left; margin-left:10px; text-align: center; background:gray ">' +
                      "</div></br>";
                    value += '<div style="width:80px"><span style="float:left;">Не исп.</span></div>';
                  } else {
                    value = "";
                  }
                }

                document.getElementById("rkps_dzn_" + rkps_number)
                  ? (document.getElementById("rkps_dzn_" + rkps_number).innerHTML = value)
                  : "";
              }
            } else {
              if (!(f6_bit & 0x800)) {
                // нет батареи 2
                if (f6_bit & 0x2000) {
                  // 13 Бит
                  //    $.styleRkpsZone(rkps_number, '')
                  value =
                    '<div style="color:#fff; height:50px;line-height: 50px; width:50px; float: left; margin-left:10px; text-align: center; background:#468966; ">РВ' +
                    "</div></br>";
                  value += '<div style="float:left;><span style="padding-left:12px">ВКЛ</span></div>';
                } else {
                  value =
                    '<div style="color:#fff; height:50px;line-height: 50px; width:50px; float: left; margin-left:10px; text-align: center; background:gray; ">РВ' +
                    "</div></br>";
                  value += '<div style="width:80px"><span style="float:left; padding-left:12px">ВЫКЛ</span></div>';
                }
              } else {
                value =
                  '<div style="color:#fff; height:50px;line-height: 50px; width:50px; float: left; margin-left:10px; text-align: center; background:#ff9800; ">РВ' +
                  "</div></br>";
                value += '<div style="width:80px"><span style="float:left;"><strike>Питание</strike></span></div>';
              }
              document.getElementById("rkps_dzn_" + rkps_number)
                ? (document.getElementById("rkps_dzn_" + rkps_number).innerHTML = value)
                : "";
            }
            // ... ДОПОЛНИТЕЛЬНАЯ ЗОНА НАРУШЕНА

            // БАТАРЕЯ 2...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            switch (devModel) {
              case "17620":
                if (rkps_dom) {
                  if (!(f6_bit & 0x800)) {
                    // Батареи 2 нет
                    if (f6_bit & 0x400) {
                      // 10 Бит
                      value = battary_two ? '<span style="color:red">' + battary_two + "</span>" : "";
                    } else {
                      value = battary_two ? '<span style="color:green">' + battary_two + "</span>" : "";
                    }

                    document.getElementById("rkps_powerBank_" + rkps_number)
                      ? (document.getElementById("rkps_powerBank_" + rkps_number).innerHTML = value)
                      : "";

                  } else {
                    // Батареи 2 нет
                    value = '<span style="color:red; ">Нет</span>';
                    document.getElementById("rkps_powerBank_" + rkps_number)
                      ? (document.getElementById("rkps_powerBank_" + rkps_number).innerHTML = value)
                      : "";
                  }
                }
                break;
              /*   case "16270":
                  if (rkps_dom) {
                    if (!(f6_bit & 0x800)) {
                      // Батареи 2 нет
                      if (f6_bit & 0x400) {
                        // 10 Бит
                        value = battary_two ? '<span style="color:red">' + battary_two + "</span>" : "";
                      } else {
                        value = battary_two ? '<span style="color:green">' + battary_two + "</span>" : "";
                      }
  
                      document.getElementById("rkps_powerBank_" + rkps_number)
                        ? (document.getElementById("rkps_powerBank_" + rkps_number).innerHTML = value)
                        : "";
                    } else {
                      // Батареи 2 нет
                      value = '<span style="color:red; ">Нет</span>';
                      document.getElementById("rkps_powerBank_" + rkps_number)
                        ? (document.getElementById("rkps_powerBank_" + rkps_number).innerHTML = value)
                        : "";
                    }
                  }
                  break; */
              default:
                break;
            }
            if (rkps_device[rkps_number].name == "16270" || rkps_device[rkps_number].name == "13431" || rkps_device[rkps_number].name == "13438" || rkps_device[rkps_number].name == "13439") {
              if (rkps_dom) {
                if (!(f6_bit & 0x800)) {

                  if (f6_bit & 0x400) {
                    // 10 Бит
                    value = battary_two ? '<span style="color:red">' + battary_two + "</span>" : "";
                  } else {
                    value = battary_two ? '<span style="color:green">' + battary_two + "</span>" : "";
                  }

                  document.getElementById("rkps_powerBank_" + rkps_number)
                    ? (document.getElementById("rkps_powerBank_" + rkps_number).innerHTML = value)
                    : "";

                }
                else {
                  // Батареи 2 нет
                  value = '<span style="color:red;">Нет</span>';
                  document.getElementById("rkps_powerBank_" + rkps_number)
                    ? (document.getElementById("rkps_powerBank_" + rkps_number).innerHTML = value)
                    : "";
                }
                /*      if (battary_two[0] === '0') {
                       value = '';
                       document.getElementById("rkps_powerBank_" + rkps_number)
                         ? (document.getElementById("rkps_powerBank_" + rkps_number).innerHTML = value)
                         : "";
                     } */
              }
            }
            // ... БАТАРЕЯ 2

            // САБОТАЖ ОСНОВНОЙ ЗОНЫ ...
            rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            switch (devModel) {
              case "17620":
                document.getElementById("rkps_sabotag_" + rkps_number)
                  ? (document.getElementById("rkps_sabotag_" + rkps_number).innerHTML = "")
                  : "";
                break;
              case "16270":
                document.getElementById("rkps_sabotag_" + rkps_number)
                  ? (document.getElementById("rkps_sabotag_" + rkps_number).innerHTML = "")
                  : "";
                break;

              case "15130":
                if (rkps_dom) {
                  value = f6_bit;
                  if (value & 0x800) {
                    // 11 Бит
                    value = '<span style="color:red">Саботаж</span>';
                  } else {
                    value = "";
                  }
                  document.getElementById("rkps_sabotag_" + rkps_number)
                    ? (document.getElementById("rkps_sabotag_" + rkps_number).innerHTML = value)
                    : "";
                }
                break;
            }

            // ... САБОТАЖ ОСНОВНОЙ ЗОНЫ

            // РП резервное питание ...
            // rkps_dom = document.getElementById("rkps_number_" + data.result.config[i].key.slice(4));
            // if (rkps_dom) {
            //     value = data.result.config[i].subvalues[5].value;
            //     if (value & 0x1000) {
            //         value = 'Резерв.';
            //     } else {
            //         value = 'Осн.';
            //     }
            //     document.getElementById('rkps_rezervpower_' + rkps_number) ? document.getElementById('rkps_rezervpower_' + rkps_number).innerHTML = value : "";
            // }
            //... РП резервное питание
          } else {
            let rkps_number = data.result.config[i].key.slice(4); // НОМЕР РК ДАТЧИКА
            document.getElementById("rkps_program_" + rkps_number)
              ? (document.getElementById("rkps_program_" + rkps_number).innerHTML =
                '<span style="color:red">Нет</span>')
              : "";
          }
        }
      } // До сюда
    }
  } catch (err) {
    console.log('err', err);
    alert(err)
  }


}
